package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.CoeficienteTarifaDAO;
import com.rjconsultores.ventaboletos.entidad.CoeficienteTarifa;

@Repository("coeficienteTarifaDAO")
public class CoeficienteTarifaHibernateDAO extends GenericHibernateDAO<CoeficienteTarifa, Integer>
		implements CoeficienteTarifaDAO {

	@Autowired
	public CoeficienteTarifaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<CoeficienteTarifa> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.addOrder(Order.asc("descCoeficiente"));

		return c.list();
	}

	@Override
	public List<CoeficienteTarifa> buscar(String nomb) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.ilike("descCoeficiente", nomb, MatchMode.START));
		c.addOrder(Order.asc("descCoeficiente"));

		return c.list();
	}
}
